/* cosignmsg.mc
  

  Messages for the IISCosign ISAPI filter DLL.


*/
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: CS_STARTED
//
// MessageText:
//
//  IISCosign %1 successfully loaded.
//
#define CS_STARTED                       ((DWORD)0x00000001L)

//
// MessageId: CS_STOPPING
//
// MessageText:
//
//  IISCosign %1 is unloading.
//
#define CS_STOPPING                      ((DWORD)0x00000002L)

//
// MessageId: CS_XMLLOADFAILED
//
// MessageText:
//
//  Could not load the cosign config file %1.
//
#define CS_XMLLOADFAILED                 ((DWORD)0x00000003L)

//
// MessageId: CS_CONNECTIONPOOLBUSY
//
// MessageText:
//
//  Connection pool is busy.  Perhaps the current size is too low?  This value can be changed in the cosign.dll.config file.
//
#define CS_CONNECTIONPOOLBUSY            ((DWORD)0x00000004L)

//
// MessageId: CS_ACCESSDENIED
//
// MessageText:
//
//  IISCosign does not have permission to access something.  Please see the readme.txt file for
//  information about setting file permissions for IISCosign.  Here is what caused the error:
//  %1
//
#define CS_ACCESSDENIED                  ((DWORD)0x00000005L)

//
// MessageId: CS_WEBSITENOTFOUND
//
// MessageText:
//
//  The config file specified that the web site %1 should be protected, but it could not be found in the Metabase. 
//  Please be sure that the IISDescription items in cosign.dll.config match the descriptions shown in IIS Manager.
//
#define CS_WEBSITENOTFOUND               ((DWORD)0x00000006L)

//
// MessageId: CS_DEFAULTMODE
//
// MessageText:
//
//  An error occurred while IISCosign was loading.  It is now running in a minimal state that will prevent your web site from serving content.
//
#define CS_DEFAULTMODE                   ((DWORD)0x00000007L)

//
// MessageId: CS_XMLPARSEERROR
//
// MessageText:
//
//  Config file parsing error at line %1: %2.
//
#define CS_XMLPARSEERROR                 ((DWORD)0x00000008L)

//
// MessageId: CS_INITLOGFAILED
//
// MessageText:
//
//  Could not initialize log file %1.
//
#define CS_INITLOGFAILED                 ((DWORD)0x00000009L)

