
#ifndef __COSIGNSTRUCTS_H_
#define __COSIGNSTRUCTS_H_

//#include <openssl\ssl.h>
//#include <openssl\err.h>
//#include "libsnet/snet.h"

#define DEFAULTPORT	6663
//Size is in KB, default = 10 MB
#define DEFAULTLOGFILESIZE	10240

#define LOGGINGDEBUG 1
#define LOGGINGNORMAL 2

enum CS_IPCHECK { never, initial, always };

typedef struct _CosignSettings {

	BOOL	cs_runInDefaultMode;
	char*	cs_server;
	char*	cs_cookieDBPath;
	char*	cs_logFilePath;
	char*	cs_writeDataToEventViewer;
	DWORD	cs_connPoolSize;
	//Expire time is kept in 100 nanosecond intervals
	DWORD	cs_cookieDBExpireTime;
	//Size is in KB.
	DWORD	cs_logFileSize;
	DWORD	cs_logFileLevel;
	CS_IPCHECK	cs_checkIpAddr;
	BOOL	cs_redirectToHttps;
	BOOL	cs_cookieSecure;
	BOOL	cs_cookieHttpOnly;
	char*	cs_cookieOptions;
	char*	cs_CAFilePath;
	char*	cs_chainFilePath;
	char*	cs_privateKeyFilePath;
	char*	cs_redirectURL;
    char*   cs_postErrorRedirectURL;
	int		cs_port;
	BOOL    cs_getkrbtkt;
	char*	cs_krbTicketDir;
    BOOL    cs_getProxy;
 	char*	cs_proxyDir;
 	int     cs_hashlen;
    int     cs_protocolVersionNeeded;

} COSIGNSETTINGS;

struct connlist {
    struct sockaddr_in  conn_sin;
    SNET                *conn_sn;
    struct connlist     *conn_next;
};

struct connpool {
	int		cp_locked;
	struct connlist	*cp_cl;
	struct connpool *cp_next;
};

#endif
